// $Id: jquery.eyedrop.js,v 1.1.2.3 2007/02/16 15:45:53 sime Exp $
jQuery.fn.eyedrop = function () {
  $.eyedrop(this);
  return this;
};

// Called to initialize and display layers
jQuery.eyedrop = function (container) {

  var container = $(container).get(0);
  return container.eyedrop || (container.eyedrop = new jQuery._eyedrop(container));
}

jQuery._eyedrop = function (container, callback) {

  params = Drupal.parseJson($(container).attr("eyedrop"));
//  alert(params['x']+', '+params['y']+', '+params['w']+', '+params['h']);

  jQuery("#eyedrop-submit").click (function() { eye.editSubmit(); });

  // Store eyedrop object
  var eye = this;
  var img = container;

  // Setting some parameters here, need more control over these later.
  var action = 'crop';
  var target = '';
  var group = container.id.split('-').pop();

  // This is rudimentary.
  var canvasHeight = 400;
  var canvasWidth = canvasHeight * ratioOrig;
  var docHeight = self.innerHeight || jQuery.boxModel && document.documentElement.clientHeight || document.body.clientHeight;
  if ((docHeight * 0.7) < canvasHeight) {
    canvasHeight = parseInt(docHeight * 0.6);
  }

  parseInt(document.body.clientHeight) * 0.6
  var handleOffset = 4; // Displacement of handle on crop boundary
  var canvasFrame = 5; // Framework
  var imgCropMin = 10; // Minimum cropping size in pixels.

  // Get the canvas ratio (ratio of original image).
  var ratioOrig = parseInt(params['sW']) / parseInt(params['sH']);

  // Constants for key identification.
  //
  // X and Y = current mouse position
  // X1 and Y1 = starting position.
  // L and T captures the initial position of a moving object
  // W and H captures the horizontal/vertical distance from X and Y.
  // CanvasW and CanvasH captures the size of the canvas on mousedown
  var X = 0; var Y = 1; var X1 = 2; var Y1 = 3; var X2 = 4; var Y2 = 5; var L = 6; var T = 7; var W = 8; var H = 9; var CanvasW = 10; var CanvasH = 11;

  // arrays on which above constants are used.
  // drag[] is an array for capturing values during various mouse events.
  var drag = new Array(0,0,0,0,0,0,0,0,0,0,0,0);
  // limit[] is an array for setting the drag boundaries.
  var limit = new Array(0,0,0,0);


  var oCanvas = jQuery("#eye-image").get(0).style;
  // Apply canvas width;
  oCanvas.height = canvasHeight +'px';
  oCanvas.width = (canvasHeight * ratioOrig) + 'px';
//  alert(oCanvas.width+', '+oCanvas.height);


  var obj = jQuery("#eyedrop-layers").get(0).style;
  obj.height = canvasHeight +'px';
  obj.width = (canvasHeight * ratioOrig) + 'px';


//  obj.height = (canvasHeight + (2*canvasFrame))+'px';
//  obj.width = (canvasWidth + (2*canvasFrame))+'px';


  // Load the original sucker. Probably no need for a http call.
  // May replace this later, perhaps with a display:none field.
  $.getJSON("/eyedrop/request/eyedrop_field_imagepath/"+params['iid'], function(json){
    jQuery("#eye-image").attr({ src: json });
  });

  // Find the ratio between the canvas size and the original image.
  // TODO: This line is not compatible with IE6 or IE7 (getting the image size).
  var zoom = canvasHeight / parseInt(params['sH']);

  var oSelect = new Object();
  var oSelect = jQuery("#eye-crop").get(0).style;

  // The masks are the four divs surrounding the crop area.
  var oMask = new Object();
  oMask.North = jQuery("#eye-mt").get(0).style;
  oMask.West = jQuery("#eye-ml").get(0).style;
  oMask.South = jQuery("#eye-mb").get(0).style;
  oMask.East = jQuery("#eye-mr").get(0).style;

  // The handles are the images in each corner that can be dragged to resize the crop area.
  var oHand = new Object();
  oHand.NE = jQuery("#eye-ne").get(0).style;
  oHand.NW = jQuery("#eye-nw").get(0).style;
  oHand.SE = jQuery("#eye-se").get(0).style;
  oHand.SW = jQuery("#eye-sw").get(0).style;

  // Build references to the value display input elements.
  // These are the display boxes.
  var dsp = new Array();
  $("#eyedrop-parameters").find("input").each( function(i) {
    dsp[this.id.split('-').pop()] = this;
  });

/*
  // Gather the parameters for this layer.
  var params = new Array();
  $(container).find(".eyedrop-group-param").each( function(i) {
    params[this.id.split('-').pop()] = this.value;
  });
*/

  /**
   * Editor initialization
   */
  eye.initialize = function (action) {

    drag[L]  = parseInt(params['x'] * zoom);
    drag[T]  = parseInt(params['y'] * zoom);
    drag[W]  = parseInt(params['w'] * zoom);
    drag[H]  = parseInt(params['h'] * zoom);

//    alert(zoom+', '+drag[L]+', '+drag[T]+', '+drag[W]+', '+drag[H]);

    drag[CanvasH] = parseInt(oCanvas.height);
    drag[CanvasW] = (drag[CanvasH] * ratioOrig);

    oHand.SW.left = oHand.NW.left = oHand.NW.top = oHand.NE.top = "-"+handleOffset+'px';

    eye.maskResizeLeft(drag[L], drag[W], drag[CanvasW]);
    eye.maskResizeTop(drag[T], drag[H], drag[CanvasH]);
    eye.maskResizeRight(drag[L] + drag[W], drag[W], drag[CanvasW]);
    eye.maskResizeBottom(drag[T] + drag[H], drag[H], drag[CanvasH]);

  }

  /**
   * Mousedown handler
   */
  eye.mousedown = function (event) {

    // Capture mouse
    if (!document.dragging) {
      $(document).bind('mousemove', eye.mousemove).bind('mouseup', eye.mouseup);
      document.dragging = true;

      // Record the initial mouse position.
      drag[X1] = event.clientX;
      drag[Y1] = event.clientY;
      drag[CanvasW] = parseInt(oCanvas.width);
      drag[CanvasH] = (drag[CanvasW] / ratioOrig);

      target = event.target.id || event.srcElement.id;

      drag[T] = parseInt(oSelect.top);
      drag[L] = parseInt(oSelect.left);
      drag[W] = parseInt(oSelect.width);
      drag[H] = parseInt(oSelect.height);

      eye.setMouseLimits(target);

      // Process this event like a mouse move.
      eye.mousemove(event);
    }
    return false;
  }

  /**
   * Mousemove handler
   */
  eye.mousemove = function (event) {

    // Get main coordinates
    drag[X] = event.clientX;
    drag[Y] = event.clientY;

    var xMove = (drag[X] - drag[X1]);
    var yMove = (drag[Y] - drag[Y1]);

    factor = 1;
    if (target=='eye-ne' || target=='eye-sw') {
      factor = -1
    }

    if((params['aspect']!=0) && (target!='eye-crop')) {
      if (xMove > limit[X2]) {
        xMove = limit[X2];
      }
      if (xMove < limit[X1]) {
        xMove = limit[X1];
      }
      yMove = xMove * params['aspect'] *factor;

      if (yMove > limit[Y2]) {
        yMove = limit[Y2];
        xMove = yMove / params['aspect'] *factor;
      }
      if (yMove < limit[Y1]) {
        yMove = limit[Y1];
        xMove = yMove / params['aspect'] * factor;
      }
    }
    else {
      xMove = Math.max(limit[X1], Math.min (limit[X2], xMove));
      yMove = Math.max(limit[Y1], Math.min (limit[Y2], yMove));
    }

    dsp['xMove'].value = xMove;
    dsp['yMove'].value = yMove;

    switch(target) {
      case 'eye-crop':
        eye.maskMoveX(drag[L] + xMove, drag[W], drag[CanvasW]);
        eye.maskMoveY(drag[T] + yMove, drag[H], drag[CanvasH]);
        break;
      case 'eye-nw':
        eye.maskResizeLeft(drag[L] + xMove, drag[W] - xMove, drag[CanvasW]);
        eye.maskResizeTop(drag[T] + yMove, drag[H] - yMove, drag[CanvasH]);
        break;
      case 'eye-ne':
        eye.maskResizeRight(drag[L] + drag[W] + xMove, drag[W] + xMove, drag[CanvasW]);
        eye.maskResizeTop(drag[T] + yMove, drag[H] - yMove, drag[CanvasH]);
        break;
      case 'eye-sw':
        eye.maskResizeLeft(drag[L] + xMove, drag[W] - xMove, drag[CanvasW]);
        eye.maskResizeBottom(drag[T] + drag[H] + yMove, drag[H] + yMove, drag[CanvasH]);
        break;
      case 'eye-se':
        eye.maskResizeRight(drag[L] + drag[W] + xMove, drag[W] + xMove, drag[CanvasW]);
        eye.maskResizeBottom(drag[T] + drag[H] + yMove, drag[H] + yMove, drag[CanvasH]);
        break;
    }
  }

  /**
  * Mouseup handler
  */
  eye.mouseup = function () {
    // Uncapture mouse
    $(document).unbind('mousemove', eye.mousemove);
    $(document).unbind('mouseup', eye.mouseup);
    document.dragging = false;
  }

  eye.maskMoveX = function (selectLeft, selectWidth, canvasWidth) {

    oSelect.left       = selectLeft + 'px';
    oMask.West.width   = selectLeft + 'px';
    oMask.North.left   = selectLeft + 'px';
    oMask.South.width  = selectLeft + selectWidth + "px";
    oMask.East.left    = selectLeft + selectWidth + "px";
    oMask.North.width  = canvasWidth - selectLeft + "px";
    oMask.East.width   = canvasWidth - selectLeft - selectWidth + 'px';
    dsp['X'].value = selectLeft;

  }

  eye.maskMoveY = function (selectTop, selectHeight, canvasHeight) {
    oSelect.top        = selectTop + 'px';
    oMask.North.height = selectTop + 'px';
    oMask.East.top     = selectTop + 'px';
    oMask.West.height  = selectTop + selectHeight + "px";
    oMask.South.top    = selectTop + selectHeight + "px";
    oMask.East.height  = canvasHeight - selectTop + "px";
    oMask.South.height = canvasHeight - selectTop - selectHeight + 'px';
    dsp['Y'].value = selectTop;
  }

  eye.maskResizeLeft = function (selectLeft, selectWidth, canvasWidth) {
    oSelect.left      = selectLeft + 'px';
    oSelect.width     = selectWidth + 'px';
    oMask.West.width  = selectLeft + 'px';
    oMask.North.left  = selectLeft + 'px';
    oMask.North.width = canvasWidth - selectLeft + "px";
    oHand.NE.left     = selectWidth - handleOffset + "px";
    oHand.SE.left     = selectWidth - handleOffset + "px";
    dsp['W'].value = selectWidth;
  }

  eye.maskResizeRight  = function (selectRight, selectWidth, canvasWidth) {

    oSelect.width      = selectWidth + 'px';
    oMask.East.left    = selectRight + "px";
    oMask.South.width  = selectRight + "px";
    oMask.East.width   = canvasWidth - selectRight + "px";
    oHand.NE.left      = selectWidth - handleOffset + "px";
    oHand.SE.left      = selectWidth - handleOffset + "px";
    dsp['W'].value = selectWidth;
  }

  eye.maskResizeTop = function (selectTop, selectHeight, canvasHeight) {
    oSelect.top        = selectTop + 'px';
    oSelect.height     = selectHeight + 'px';
    oMask.North.height = selectTop + "px";
    oMask.East.top     = selectTop + "px";
    oMask.East.height  = canvasHeight - selectTop + "px";
    oHand.SW.top       = selectHeight - handleOffset + "px";
    oHand.SE.top       = selectHeight - handleOffset + "px";
    dsp['H'].value = selectHeight;
  }

  eye.maskResizeBottom = function (selectBottom, selectHeight, canvasHeight) {
    oSelect.height     = selectHeight + 'px';
    oMask.South.top    = selectBottom + "px";
    oMask.West.height  = selectBottom + "px";
    oMask.South.height = canvasHeight - selectBottom + "px";
    oHand.SW.top       = selectHeight - handleOffset + "px";
    oHand.SE.top       = selectHeight - handleOffset + "px";
    dsp['H'].value = selectHeight;
  }

  eye.setMouseLimits = function (target) {

    limit[X1] = parseInt(oMask.West.width) * -1;
    limit[Y1] = parseInt(oMask.North.height) * -1;
    limit[X2] = parseInt(oMask.East.width);
    limit[Y2] = parseInt(oMask.South.height);
    var width = parseInt(oSelect.width) - imgCropMin;
    var height = parseInt(oSelect.height) - imgCropMin;

    switch (target) {
      case 'eye-nw':
        limit[X2] = width;
        limit[Y2] = height;
        break;
      case 'eye-ne':
        limit[X1] = width * -1;
        limit[Y2] = height;
        break;
      case 'eye-sw':
        limit[Y1] = height * -1;
        limit[X2] = width;
        break;
      case 'eye-se':
        limit[X1] = width * -1;
        limit[Y1] = height * -1;
        break;
    }
  }

  // This some value that represents the relationship between the mouse
  // position and the actual crop -- where the ratio of width:height needs
  // to be fixed. Unfortunately I've changed the way everything works
  // and didn't document this function. Blech. Kept for posterity.
  eye.fixedRatioWidth = function (kX, kY) {
    var a1 = (Math.atan(params['aspect']) * (180 / Math.PI));
    var a2 = 90 - a1;
    var a3 = (Math.atan(kY/kX) * (180 / Math.PI))
    var a4 = a3 - a2;
    var k3 = Math.sqrt(Math.pow(kX,2)+Math.pow(kY,2));
    var k6 = Math.sin(a4 / (180 / Math.PI)) * k3;
    var finalx =  Math.cos(a1) * k6;
    return finalx;

  }

  /**
  * Mouseup handler
  */
  eye.editSubmit = function () {
    $.post("/eyedrop/request/eyedrop_field_save_parameters/"+params['nid']+"/"+params['size'],
      { x: (dsp['X'].value / zoom), y: (dsp['Y'].value / zoom), w: (dsp['W'].value / zoom), h: (dsp['H'].value / zoom) },
      function(data){
        jQuery(img).attr({ eyedrop: data });
        jQuery(img).attr({ src: jQuery(img).attr("src")+'?'+(new Date()).getTime() });
      });
      // Reverse handles
      jQuery('*', "#eyedrop-editor").unbind();

      jQuery(".eyedrop-image").unbind("click");
      jQuery(".eyedrop-image").each( function(i){
        jQuery(this).click (function() { $(this).eyedrop(); });
      });
//      jQuery(img).bind ("click", function() {
//        alert("HI");
//      });
    jQuery("#eyedrop-container").fadeOut();
  }

    // Show the editor.
  jQuery("#eyedrop-container").fadeIn('slow');

  // Initialize
  eye.initialize('crop');

  // Install mousedown handler
  jQuery('*', "#eyedrop-editor").mousedown(eye.mousedown);

  // Set linked elements/callback
  if (callback) {
    eye.linkTo(callback);
  }
}